aUFBanzai = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceHook-2.1")

local _G = getfenv(0)
local enabled = nil

local ignoredUnits = {
	["target"] = true,
	["targettarget"] = true,
	["targettargettarget"] = true,
}

function aUFBanzai:SafeHook(object, method, handler) if not self:IsHooked(object, method) then self:Hook(object, method, handler) end end
function aUFBanzai:SafeUnhook(object, method) if self:IsHooked(object, method) then self:Unhook(object, method) end end
function aUFBanzai:OnEnable() self:Enable() end

function aUFBanzai:Enable()
	if enabled then return end
	self:RegisterEvent("Banzai_UnitGainedAggro")
	self:RegisterEvent("Banzai_UnitLostAggro")
	enabled = true
end

function aUFBanzai:Disable()
	if enabled then
		self:UnregisterEvent("Banzai_UnitGainedAggro")
		self:UnregisterEvent("Banzai_UnitLostAggro")
		self:UnhookAll()
	end
	enabled = nil
end

function aUFBanzai:StyleUnit(unit)
	self:SafeHook(unit, "StatusBarsColor", "Noop")
	self:SafeHook(unit, "StatusBarsOnValueChanged", "Noop")
	unit.HealthBar:SetStatusBarColor(1, 0, 0)
end

function aUFBanzai:ResetUnit(unit)
	self:SafeUnhook(unit, "StatusBarsColor")
	self:SafeUnhook(unit, "StatusBarsOnValueChanged")
	unit:StatusBarsColor()
end

function aUFBanzai:Banzai_UnitGainedAggro(unitId)
	for k, v in pairs(aUF.unitid) do
		if not ignoredUnits[k] and UnitIsUnit(unitId, k) then
			for obj, used in pairs(aUF.unitid[k]) do
				if used then self:StyleUnit(obj) end
			end
		end
	end
end

function aUFBanzai:Banzai_UnitLostAggro(unitId)
	for k, v in pairs(aUF.unitid) do
		if not ignoredUnits[k] and UnitIsUnit(unitId, k) then
			for obj, used in pairs(aUF.unitid[k]) do
				if used then self:ResetUnit(obj) end
			end
		end
	end
end

function aUFBanzai:Noop() return nil end

